#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include "tree.h"
#include "Memory.h"
#include "Time.h"
#include "force_spline.h"
/*
#define N 116
*/
extern float ran2nran,diff[(NSPLINE+1)][4],slope[(NSPLINE+1)][4];
float ran2(long *);
void check_tree();
particle *p;
pforce *force,*force2;
void force_spline();
extern double a[8];
float epsilon2=0.04;
double f(double);
int main(int argc,char *argv[]){
	double std,mean;
	int ntmp;
	float tmpx,tmpy,tmpz,dist2;
	float fplmf,ptlmass;
	int i,j,k;
	int N,M;
	TPtlStruct *ptl;
	BeginEndTree beginend;
	Box box;
	TStruct *TREE;
	float theta = 1.;
	float wtime;
	long iseed=-9;
	FILE *fp;
	(void) ran2(&iseed);
	(void) Make_Total_Memory();
	i_force_spline();
	for(k=500;k<100000;k+=100){
		N = k;
		M = N;
		ptl = (TPtlStruct *) Malloc(sizeof(TPtlStruct)*N,PPTR(ptl));
		p = (particle *) Malloc(sizeof(particle)*M,PPTR(p));
		force = (pforce *) Malloc(sizeof(pforce)*M,PPTR(force));
		force2 = (pforce *) Malloc(sizeof(pforce)*M,PPTR(force2));
		TREE = (TStruct *) Malloc(sizeof(TStruct)*N,PPTR(TREE));
		/*
		ptl = (TPtlStruct *) malloc(sizeof(TPtlStruct)*N);
		p = (particle *) malloc(sizeof(particle)*M);
		force = (pforce *) malloc(sizeof(pforce)*M);
		force2 = (pforce *) malloc(sizeof(pforce)*M);
		TREE = (TStruct *) malloc(sizeof(TStruct)*N);
		*/
		wtime = WALLCLOCK();
		for(i=0;i<N;i++){
			ptl[i].type = TYPE_PTL;
			p[i].x = ptl[i].r[0] = ran2(&iseed);
			p[i].y = ptl[i].r[1] = ran2(&iseed);
			p[i].z = ptl[i].r[2] = ran2(&iseed);
			force[i].x = force[i].y = force[i].z = 0.;
			force2[i].x = force2[i].y = force2[i].z = 0.;
			ptl[i].sibling = &ptl[i+1];
			ptl[i].mass = 1;
		}
		for(i=N;i<M;i++){
			p[i].x = ran2(&iseed)*7;
			p[i].y = ran2(&iseed)*7;
			p[i].z = ran2(&iseed)*7;
			force[i].x = force[i].y = force[i].z = 0.;
			force2[i].x = force2[i].y = force2[i].z = 0.;
		}
		ptl[N-1].sibling = NULL;
		/* */
		(void)WALLCLOCK();
		for(i=0;i<M;i++)
			for(j=0;j<N;j++){
				float e,x;
				float tanha2x;
				float a2x,expdxx;
				e = epsilon;
				ptlmass = ptl[j].mass;
				tmpx = ptl[j].r[0] - ptl[i].r[0];
				tmpy = ptl[j].r[1] - ptl[i].r[1];
				tmpz = ptl[j].r[2] - ptl[i].r[2];
				dist2 = tmpx*tmpx + tmpy*tmpy + tmpz*tmpz;
				x = sqrt(dist2);
				if(x == 0.) continue;
				fplmf = f(x);
				force2[i].x += tmpx*fplmf/x;
				force2[i].y += tmpy*fplmf/x;
				force2[i].z += tmpz*fplmf/x;
			}
		printf("%g  ellapsed for direct cal.",WALLCLOCK());
		/* */
		box.x = box.y = box.z = 0.;
		box.width = 1.;
		Make_Tree(TREE,ptl,N,box);
		printf("%g  ellapsed ..",WALLCLOCK());
		printf("%d :",N);
		/*
		check_tree(TREE,ptl);
		*/
		for(i=0;i<M;i++){
			treeforce(p+i,theta,TREE,ptl,force+i);
		}
		/*
		for(i=0;i<M;i++){
			potent[i] = treeplumpotential(p+i,theta,TREE,ptl,epsilon);
		}
		*/
		printf("%g  ellapsed \n",WALLCLOCK());
		mean = std = 0.;
		fp = fopen("Err.dat","a");
		for(i=0;i<M;i++){
			float tmpforce;
			float diff;
			dist2 = (force2[i].x*force2[i].x) + (force2[i].y*force2[i].y)+
				(force2[i].z*force2[i].z);
			dist2 = sqrt(dist2);
			tmpforce = pow(force[i].x,2) + pow(force[i].y,2) +
				pow(force[i].z,2);
			tmpforce = sqrt(tmpforce);
			diff = (tmpforce-dist2)/dist2;
			fprintf(fp,"%g %g\n",dist2,diff);
			mean += diff;
			std += diff*diff;
		}
		fclose(fp);
		mean /= M;
		std = std/M - mean*mean;
		std = sqrt(std);
		printf("force err mean %g= , std = %g\n",mean,std);
		Free(TREE);Free(ptl);Free(p);Free(force);Free(force2);
		/*
		free(ptl);free(p);free(force);free(force2);free(TREE);
		*/
	}
	fprintf(stdout,"Terminated with success\n");fflush(stdout);
	return 1;
}
#define IM1 2147483563
#define IM2 2147483399
#define AM (1.0/IM1)
#define IMM1 (IM1-1)
#define IA1 40014
#define IA2 40692
#define IQ1 53668
#define IQ2 52774
#define IR1 12211
#define IR2 3791
#define NTAB 32
#define NDIV (1+IMM1/NTAB)
#define EPS 1.2e-7
#define RNMX (1.0-EPS)

float ran2(long *idum)
{
	int j;
	long k;
	static long idum2=123456789;
	static long iy=0;
	static long iv[NTAB];
	float temp;

	if (*idum <= 0) {
		if (-(*idum) < 1) *idum=1;
		else *idum = -(*idum);
		idum2=(*idum);
		for (j=NTAB+7;j>=0;j--) {
			k=(*idum)/IQ1;
			*idum=IA1*(*idum-k*IQ1)-k*IR1;
			if (*idum < 0) *idum += IM1;
			if (j < NTAB) iv[j] = *idum;
		}
		iy=iv[0];
	}
	k=(*idum)/IQ1;
	*idum=IA1*(*idum-k*IQ1)-k*IR1;
	if (*idum < 0) *idum += IM1;
	k=idum2/IQ2;
	idum2=IA2*(idum2-k*IQ2)-k*IR2;
	if (idum2 < 0) idum2 += IM2;
	j=iy/NDIV;
	iy=iv[j]-idum2;
	iv[j] = *idum;
	if (iy < 1) iy += IMM1;
	if ((temp=AM*iy) > RNMX) return RNMX;
	else return temp;
}
#undef IM1
#undef IM2
#undef AM
#undef IMM1
#undef IA1
#undef IA2
#undef IQ1
#undef IQ2
#undef IR1
#undef IR2
#undef NTAB
#undef NDIV
#undef EPS
#undef RNMX
/* (C) Copr. 1986-92 Numerical Recipes Software 71.+I0>+. */
