c: Kim, Juhan's program
c:    ver. 1.0 : Simple calculation .
c:    Use spline kernel W4 in density assign
c:    OLD_DEPTH option is included  10/11/01
      subroutine haloseed(den,pden,nwidth,maxx,maxy,maxz,
     &                     ppoint,np,peak,mpeak,haloppoint,
     &                     downhalovalue,numhaloseed,endhaloseed,
     &                    included,peakincluded,Parallel,
     &                    myrank,motherrank,nrank,
#ifdef OLD_DEPTH
     &                    nposdepth,nxdepth,nydepth,nzdepth
#else
     &                    nposdepth
#endif
     &                    )
      INCLUDE 'sub_find_dimension.inc'
      INCLUDE 'mpif.h'
      integer fstatus(MPI_STATUS_SIZE),cstatus(MPI_STATUS_SIZE)
      real den(-nwidth+1:maxx+nwidth,-nwidth+1:maxy+nwidth,
     &             -nwidth+1:maxz+nwidth)
      integer pden(-nwidth+1:maxx+nwidth,-nwidth+1:maxy+nwidth,
     &             -nwidth+1:maxz+nwidth)
      logical*1 included(-nwidth+1:maxx+nwidth,-nwidth+1:maxy+nwidth,
     &             -nwidth+1:maxz+nwidth)
#ifdef OLD_DEPTH
      integer nposdepth(0:*)
      integer nxdepth(0:*),nydepth(0:*),nzdepth(0:*)
#else 
      integer nposdepth(0:*)
#endif
      logical peakincluded(mpeak)
      integer maxx,maxy,maxz
      integer haloppoint(mpeak)
      integer halopp
      integer ppoint(np)
      integer peak(3,mpeak)
      integer Parallel
      integer ready
      real downhalovalue(mpeak)
      real oldthr,newthr
      integer numhaloseed(mpeak),endhaloseed(mpeak)

#ifdef CHECK_INFORM
         print *, 'now in haloseed_ function'
#endif
c--------------------------------------------------------------
      if(Parallel == 0) then
         do i = 1, mpeak
            do j = 1, mpeak
               peakincluded(j) = .FALSE.
            enddo
            oldthr = den(peak(1,i),peak(2,i),peak(3,i))
            peakincluded(i) = .TRUE.
            newthr = 0.0
            npx = peak(1,i)
            npy = peak(2,i)
            npz = peak(3,i)
            haloppoint(i) = 0
            call sub_halo_particle(den,nwidth,maxx,maxy,maxz,
     &                         npx,npy,npz,
     &                         oldthr,newthr,included,peakincluded,
     &                         peak,mpeak,
c ppoint,np,pden,haloppoint(i),
#ifdef OLD_DEPTH
     &                         nposdepth,nxdepth,nydepth,nzdepth
#else
     &                         nposdepth
#endif
     &                      )
            call point_halo_region(den,nwidth,maxx,maxy,maxz,
     &           npx,npy,npz,
     &           newthr,included,ppoint,np,pden,haloppoint(i),
#ifdef OLD_DEPTH
     &           nposdepth,nxdepth,nydepth,nzdepth
#else
     &           nposdepth
#endif
     &           )
            downhalovalue(i) = newthr
            mtmp = haloppoint(i)
            j = 0
            do while(mtmp.ne.0)
               mntmp = mtmp
               mtmp = ppoint(mtmp)
               j = j + 1
            enddo
            numhaloseed(i) = j
            endhaloseed(i) = mntmp
#ifdef CHECK_INFORM
 	    print *, 'now in haloseed_',i,' get downhalovalue',newthr
#endif
         enddo
c----------------------------------------------------------------------
      else
         if(myrank .eq. motherrank) then
            call initden(den,nwidth,maxx,maxy,maxz,mpeak,peak)
            nrecv = 0
            do i = 1, mpeak
 888           continue
               call MPI_Recv(ready,1,MPI_INTEGER,MPI_ANY_SOURCE,
     &             MPI_ANY_TAG,MPI_COMM_WORLD,fstatus,ierror)
               if(ready .eq. MREADY) then
                   call MPI_Send(i,1,MPI_INTEGER,fstatus(MPI_SOURCE),
     &                MCOREDEN_TAG,MPI_COMM_WORLD,ierror)
               else if(ready .eq. MCOREDEN_TAG) then
                   call MPI_Recv(nowpeak,1,MPI_INTEGER,
     &                fstatus(MPI_SOURCE),MCOREDEN_TAG,MPI_COMM_WORLD,
     &                cstatus,ierror)
                   call MPI_Recv(newthr,1,MPI_REAL,
     &                fstatus(MPI_SOURCE),MCOREDEN_TAG,MPI_COMM_WORLD,
     &                cstatus,ierror)
#if CHECK_INFORM
	               print *,'get density value',nowpeak,newthr
#endif
                   npx = peak(1,nowpeak)
                   npy = peak(2,nowpeak)
                   npz = peak(3,nowpeak)
				   haloppoint(nowpeak) = 0
                   call point_halo_region(den,nwidth,maxx,maxy,maxz,
     &               npx,npy,npz,
     &               newthr,included,ppoint,np,pden,haloppoint(nowpeak),
#ifdef OLD_DEPTH
     &                 nposdepth,nxdepth,nydepth,nzdepth
#else
     &                 nposdepth
#endif
     &                 )
                   downhalovalue(nowpeak) = newthr
                   mtmp = haloppoint(nowpeak)
                   j = 0
                   do while(mtmp.ne.0)
                      mntmp = mtmp
                      mtmp = ppoint(mtmp)
                      j = j + 1
                   enddo
                   numhaloseed(nowpeak) = j
                   endhaloseed(nowpeak) = mntmp
                   nrecv = nrecv + 1
                   goto 888
               endif
            enddo
c-- proceed the remaining jobs
            do i = nrecv+1, mpeak
                call MPI_Recv(ready,1,MPI_INTEGER,
     &             MPI_ANY_SOURCE,MCOREDEN_TAG,MPI_COMM_WORLD,
     &             cstatus,ierror)
                call MPI_Recv(nowpeak,1,MPI_INTEGER,
     &             cstatus(MPI_SOURCE),MCOREDEN_TAG,MPI_COMM_WORLD,
     &             cstatus,ierror)
                call MPI_Recv(newthr,1,MPI_REAL,
     &             cstatus(MPI_SOURCE),MCOREDEN_TAG,MPI_COMM_WORLD,
     &             cstatus,ierror)
#if CHECK_INFORM
                print *,'get density value',nowpeak,newthr
#endif
                npx = peak(1,nowpeak)
                npy = peak(2,nowpeak)
                npz = peak(3,nowpeak)
 	            haloppoint(nowpeak) = 0
                call point_halo_region(den,nwidth,maxx,maxy,maxz,
     &             npx,npy,npz,
     &             newthr,included,ppoint,np,pden,haloppoint(nowpeak),
#ifdef OLD_DEPTH
     &              nposdepth,nxdepth,nydepth,nzdepth
#else
     &              nposdepth
#endif
     &              )
                downhalovalue(nowpeak) = newthr
                mtmp = haloppoint(nowpeak)
                j = 0
                do while(mtmp.ne.0)
                   mntmp = mtmp
                   mtmp = ppoint(mtmp)
                   j = j + 1
                enddo
                numhaloseed(nowpeak) = j
                endhaloseed(nowpeak) = mntmp
            enddo
            do i = 1, nrank-1
                call MPI_Recv(ready,1,MPI_INTEGER,i,MREADY,
     &             MPI_COMM_WORLD,fstatus,ierror)
                ready = NFINISH
                call MPI_Send(ready,1,MPI_INTEGER,i,MCOREDEN_TAG,
     &             MPI_COMM_WORLD,ierror)
            enddo
c--  process for other CPU
         else
 999        continue
            ready = MREADY
            call MPI_Send(ready,1,MPI_INTEGER,motherrank,MREADY,
     &         MPI_COMM_WORLD,ierror)
            call MPI_Recv(im,1,MPI_INTEGER,motherrank,MCOREDEN_TAG,
     &         MPI_COMM_WORLD,cstatus,ierror)
            if(im .ne. NFINISH) then
               do j = 1, mpeak
                  peakincluded(j) = .FALSE.
               enddo
               oldthr = den(peak(1,im),peak(2,im),peak(3,im))
               peakincluded(im) = .TRUE.
               newthr = 0.0
               npx = peak(1,im)
               npy = peak(2,im)
               npz = peak(3,im)
               call sub_halo_particle(den,nwidth,maxx,maxy,maxz,
     &            npx,npy,npz,oldthr,newthr,included,peakincluded,
     &            peak,mpeak,
#ifdef OLD_DEPTH
     &            nposdepth,nxdepth,nydepth,nzdepth
#else
     &            nposdepth
#endif
     &            )
#if CHECK_INFORM
	           print *,'put density value',im,newthr
#endif
               ready = MCOREDEN_TAG
               call MPI_Send(ready,1,MPI_INTEGER,motherrank,
     &            MCOREDEN_TAG,MPI_COMM_WORLD,ierror)
               call MPI_Send(im,1,MPI_REAL,motherrank,MCOREDEN_TAG,
     &            MPI_COMM_WORLD,ierror)
               call MPI_Send(newthr,1,MPI_REAL,motherrank,MCOREDEN_TAG,
     &            MPI_COMM_WORLD,ierror)
               goto 999
            endif
         endif
      endif
c----------------------------------------------------------------------
100   format('halo',i5,' number is : ',i7,' threshold is :',
     &         1x,f11.6,1x,f11.6)
      return
      end

c******************************************************************
      subroutine sub_halo_particle(den,nwidth,maxx,maxy,maxz,
     &                         npx,npy,npz,
     &                       oldthr,newthr,included,peakincluded,
     &                       peak,mpeak,
c ppoint,np,pden,halopp,
#ifdef OLD_DEPTH
     &                       nposdepth,nxdepth,nydepth,nzdepth
#else
     &                       nposdepth
#endif
     &                       )
      INCLUDE 'sub_find_dimension.inc'
      real den(-nwidth+1:maxx+nwidth,-nwidth+1:maxy+nwidth,
     &             -nwidth+1:maxz+nwidth)
      logical*1 included(-nwidth+1:maxx+nwidth,-nwidth+1:maxy+nwidth,
     &             -nwidth+1:maxz+nwidth)
#ifdef OLD_DEPTH
      integer nposdepth(0:*)
      integer nxdepth(0:*),nydepth(0:*),nzdepth(0:*)
#else
      integer nposdepth(0:*)
#endif
      logical peakincluded(mpeak)
      integer maxx,maxy,maxz
      integer peak(3,mpeak)
      real oldthr,newthr
      real bottom, top
      integer npx,npy,npz
      real upthr, downthr
c     integer ppoint(np) 
c     integer pden(-nwidth+1:maxx+nwidth,-nwidth+1:maxy+nwidth,
c    &             -nwidth+1:maxz+nwidth)
      integer halopp,niter
cccccccccccccccccc inserted to accelerate this subroutine
      real*4 dist,mindist
      integer mx,my,mz,mstep
      real*4 xvec,yvec,zvec
      integer iix,iiy,iiz
      if(mpeak .le. 1) then
         newthr = 0.
         return
      endif
      mindist = (maxx+maxy+maxz)**2
      do i = 1, mpeak
          dist = (npx-peak(1,i))**2 + (npy-peak(2,i))**2 
     &            + (npz-peak(3,i))**2
          if(dist .ne. 0.) then
             mindist = amin1(mindist,dist)
             if(mindist .eq. dist) then
                 mx = peak(1,i)
                 my = peak(2,i)
                 mz = peak(3,i)
             endif
          endif
      enddo
#ifdef CHECK_INFORM
      print *,'end of finding nearest peak'
#endif
      xvec = mx - npx
      yvec = my - npy
      zvec = mz - npz
      dist = sqrt(mindist)
      xvec = xvec / (dist) *0.5
      yvec = yvec / (dist) *0.5
      zvec = zvec / (dist) *0.5
      mstep = dist*2+1
      newthr = den(npx,npy,npz)
      do i = 1, mstep
           iix = nint(npx+xvec*i)
           iiy = nint(npy+yvec*i)
           iiz = nint(npz+zvec*i)
           newthr = amin1(newthr,den(iix,iiy,iiz))
      enddo
      bottom = newthr
      top = oldthr
#ifdef CHECK_INFORM
      print *,'bottom density :',bottom,' at a peak:',top
#endif
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      upthr = oldthr
      downthr = newthr
      newthr = (upthr+downthr)/2.
      niter = 0
10    call halo_region(den,nwidth,maxx,maxy,maxz,npx,npy,npz,newthr,
     &                included,
#ifdef OLD_DEPTH
     &                nposdepth,nxdepth,nydepth,nzdepth
#else
     &                nposdepth
#endif
     &                )
      j = 0
      do i = 1, mpeak
         if((included(peak(1,i),peak(2,i),peak(3,i)).eqv..TRUE.) .and.
     &      (peakincluded(i).eqv. .FALSE.)) then
            j = 1
         endif
      enddo
      if(j.eq.0) then
         upthr = newthr
         newthr = (upthr+downthr)/2.
      else
         downthr = newthr
         newthr = (upthr+downthr)/2.
      endif
      if(abs(downthr-upthr).lt. exactthreshold) then
         newthr = upthr
      else
         niter = niter + 1
         goto 10
      endif
#ifdef CHECK_INFORM
      print *,'bottom :',bottom,'newthr ',newthr,' at a peak:',
     &     top,'niter ',niter
#endif
      return
      end
c******************************************************************
      subroutine scoop_residual(den,nwidth,maxx,maxy,maxz,included,
     &                      ppoint,np,pden,halopp)
      INCLUDE 'sub_find_dimension.inc'
      real den(-nwidth+1:maxx+nwidth,-nwidth+1:maxy+nwidth,
     &             -nwidth+1:maxz+nwidth)
      logical*1 included(-nwidth+1:maxx+nwidth,-nwidth+1:maxy+nwidth,
     &             -nwidth+1:maxz+nwidth)
      integer pden(-nwidth+1:maxx+nwidth,-nwidth+1:maxy+nwidth,
     &             -nwidth+1:maxz+nwidth)
      integer nwidth,maxx,maxy,maxz
      integer np,halopp
      integer ppoint(np)
      integer i,j,k

      halopp = 0
      do 10 k = 1, maxz
      do 10 j = 1, maxy
      do 10 i = 1, maxx
          if(pden(i,j,k) .ne. 0) then
#ifdef CHECK_INFORM
c            print *,'halo pointer', pden(i,j,k)
#endif
             ntmp = halopp
             halopp = pden(i,j,k)
             pden(i,j,k) = 0
             mtmp = halopp
             do while (mtmp.ne.0)
                mntmp = mtmp
                mtmp = ppoint(mtmp)
             enddo
             ppoint(mntmp) = ntmp
          endif
10    continue
      return
      end
c**********************************************************************
      subroutine point_halo_region(den,nwidth,maxx,maxy,maxz,
     &                     npx,npy,npz,threshold,included,
     &                   ppoint,np,pden,halopp,
#ifdef OLD_DEPTH
     &        nposdepth,nxdepth,nydepth,nzdepth
#else
     &        nposdepth
#endif
     &        )

      INCLUDE 'sub_find_dimension.inc'
      real den(-nwidth+1:maxx+nwidth,-nwidth+1:maxy+nwidth,
     &             -nwidth+1:maxz+nwidth)
      logical*1 included(-nwidth+1:maxx+nwidth,-nwidth+1:maxy+nwidth,
     &             -nwidth+1:maxz+nwidth)
      integer maxx,maxy,maxz,MMAXX,MMAXY,MMAXZ
      real threshold
      integer npx,npy,npz
#ifdef OLD_DEPTH
      integer nposdepth(0:*)
      integer nxdepth(0:*),nydepth(0:*),nzdepth(0:*)
#else
      integer nposdepth(0:*)
#endif
      integer mpx,mpy,mpz
      integer ppoint(np)
      integer pden(-nwidth+1:maxx+nwidth,-nwidth+1:maxy+nwidth,
     &             -nwidth+1:maxz+nwidth)
      integer halopp
      integer niter
	  MMAXX = maxx + 1
	  MMAXY = maxy + 1
	  MMAXZ = maxz + 1

      halopp = 0
      call init_included(included,nwidth,maxx,maxy,maxz)
      m = 0
      if(den(npx,npy,npz).lt.threshold) return
      mpx = npx
      mpy = npy
      mpz = npz
      included(mpx,mpy,mpz) = .TRUE.
      if(pden(mpx,mpy,mpz).eq.0) goto 10
      ntmp = halopp
      halopp = pden(mpx,mpy,mpz)
cccccccccccccccccccccccccccccccccccc
      pden(mpx,mpy,mpz) = 0
cccccccccccccccccccccccccccccccccccc
      mtmp = halopp
      do while (mtmp.ne.0)
         mntmp = mtmp
         mtmp = ppoint(mtmp)
      enddo
      ppoint(mntmp) = ntmp
10    continue

      i = 1
#ifdef OLD_DEPTH
      nposdepth(0) = 1
      nxdepth(0) = mpx
      nydepth(0) = mpy
      nzdepth(0) = mpz
#else
      nposdepth(0) = mpx + mpy * MMAXX + (mpz*MMAXX*MMAXY)
#endif
1000  continue
      i1 = mod(i-1,3) - 1
      i2 = mod((i-1)/3,3) - 1
      i3 = (i-1)/9 - 1
      i1 = i1+mpx
      i2 = i2+mpy
      i3 = i3+mpz
#ifdef OLD_DEPTH
      nposdepth(m) = i
#else
      nposdepth(m) = nposdepth(m) + (MMAXX)*(MMAXY)*(MMAXZ)
#endif
      if(i1.gt.maxx .or. i1.lt.1 .or. i2.gt.maxy .or. i2.lt.1 .or.
     &   i3.gt.maxz .or. i3.lt.1) goto 1001
      if((den(i1,i2,i3).ge.threshold) .and.
     &         (included(i1,i2,i3).eqv..FALSE.)) then
         included(i1,i2,i3) = .TRUE.
         if(pden(i1,i2,i3).eq.0) goto 20
         ntmp = halopp
         halopp = pden(i1,i2,i3)
cccccccccccccccccccccccccccccccccccc
         pden(i1,i2,i3) = 0
cccccccccccccccccccccccccccccccccccc
         mtmp = halopp
         do while (mtmp.ne.0)
            mntmp = mtmp
            mtmp = ppoint(mtmp)
         enddo
         ppoint(mntmp) = ntmp
20       continue

         m = m + 1
#ifdef OLD_DEPTH
         nxdepth(m) = i1
         nydepth(m) = i2
         nzdepth(m) = i3
#else
         nposdepth(m) = i1 + i2*MMAXX + i3*(MMAXX)*(MMAXY)
#endif
         mpx = i1
         mpy = i2
         mpz = i3
         i = 1
c        if(m .eq. ndepth) print *, 'Wow exceeded!!!!!!!!'
         goto 1000
      endif
1001  continue
      i = i + 1
      if(i.le.ndimension) goto 1000

      if(m.ge.1) then
         m = m - 1
#ifdef OLD_DEPTH
         mpx = nxdepth(m)
         mpy = nydepth(m)
         mpz = nzdepth(m)
         i = nposdepth(m)
#else
         i = nposdepth(m)/(MMAXX*MMAXY*MMAXZ)
		 mpz = (nposdepth(m)-i*MMAXX*MMAXY*MMAXZ)/(MMAXX*MMAXY)
		 mpy = (nposdepth(m)-i*MMAXX*MMAXY*MMAXZ-mpz*MMAXX*MMAXY)/MMAXX
         mpx = nposdepth(m) - (nposdepth(m)/MMAXX)*MMAXX
c        mpx = mod(nposdepth(m),MMAXX)
#endif
         goto 1001
      endif
      return
      end

c******************************************************************
      subroutine halo_region(den,nwidth,maxx,maxy,maxz,npx,npy,npz,
     &                       threshold,included,
#ifdef OLD_DEPTH
     &    nposdepth,nxdepth,nydepth,nzdepth
#else
     &    nposdepth
#endif
     &    )
      INCLUDE 'sub_find_dimension.inc'
      real den(-nwidth+1:maxx+nwidth,-nwidth+1:maxy+nwidth,
     &             -nwidth+1:maxz+nwidth)
      logical*1 included(-nwidth+1:maxx+nwidth,-nwidth+1:maxy+nwidth,
     &             -nwidth+1:maxz+nwidth)
      integer maxx,maxy,maxz,MMAXX,MMAXY,MMAXZ
      real threshold
      integer npx,npy,npz
#ifdef OLD_DEPTH
      integer nposdepth(0:*)
      integer nxdepth(0:*),nydepth(0:*),nzdepth(0:*)
#else
      integer nposdepth(0:*)
#endif
      integer mpx,mpy,mpz
	  MMAXX = maxx + 1
	  MMAXy = maxy + 1
	  MMAXz = maxz + 1

      call init_included(included,nwidth,maxx,maxy,maxz)
      m = 0
      if(den(npx,npy,npz).lt.threshold) return
      mpx = npx
      mpy = npy
      mpz = npz
      included(mpx,mpy,mpz) = .TRUE.
      i = 1
#ifdef OLD_DEPTH
c     nposdepth(0) = 1
      nxdepth(0) = mpx
      nydepth(0) = mpy
      nzdepth(0) = mpz
#else
      nposdepth(0) = mpx + mpy*MMAXX + (mpz)*(MMAXX)*(MMAXY)
#endif
1000  continue
      i1 = mod(i-1,3) - 1
      i2 = mod((i-1)/3,3) - 1
      i3 = (i-1)/9 - 1
      i1 = i1+mpx
      i2 = i2+mpy
      i3 = i3+mpz
#ifdef OLD_DEPTH
      nposdepth(m) = i
#else
      nposdepth(m) = nposdepth(m) + (MMAXX)*(MMAXY)*(MMAXZ)
#endif
      if(i1.gt.maxx .or. i1.lt.1 .or. i2.gt.maxy .or. i2.lt.1 .or.
     &   i3.gt.maxz .or. i3.lt.1) goto 1001
      if((den(i1,i2,i3).ge.threshold) .and.
     &         (included(i1,i2,i3).eqv..FALSE.)) then
         included(i1,i2,i3) = .TRUE.
         m = m + 1
#ifdef OLD_DEPTH
         nxdepth(m) = i1
         nydepth(m) = i2
         nzdepth(m) = i3
#else
         nposdepth(m) = i1 + i2*MMAXX + i3*(MMAXX)*(MMAXY)
#endif
         mpx = i1
         mpy = i2
         mpz = i3
         i = 1
         goto 1000
      endif
1001  continue
      i = i + 1
      if(i.le.ndimension) goto 1000

      if(m.ge.1) then
         m = m - 1
#ifdef OLD_DEPTH
         mpx = nxdepth(m)
         mpy = nydepth(m)
         mpz = nzdepth(m)
         i = nposdepth(m)
#else
         i = nposdepth(m)/(MMAXX*MMAXY*MMAXZ)
		 mpz = (nposdepth(m)-i*MMAXX*MMAXY*MMAXZ)/(MMAXX*MMAXY)
		 mpy = (nposdepth(m)-i*MMAXX*MMAXY*MMAXZ-mpz*MMAXX*MMAXY)/MMAXX
         mpx = nposdepth(m)-(nposdepth(m)/MMAXX)*MMAXX
c        mpx = mod(nposdepth(m),MMAXX)
#endif
         goto 1001
      endif
      return
      end
C************************************************************************
      subroutine init_included(included,nwidth,maxx,maxy,maxz)
      INCLUDE 'sub_find_dimension.inc'
      logical*1 included(-nwidth+1:maxx+nwidth,-nwidth+1:maxy+nwidth,
     &             -nwidth+1:maxz+nwidth)
      integer maxx,maxy,maxz

c     do 10 k = 1, maxz
c     do 10 j = 1, maxy
c     do 10 i = 1, maxx
      do 10 k = -nwidth+1,maxz+nwidth
      do 10 j = -nwidth+1,maxy+nwidth
      do 10 i = -nwidth+1,maxx+nwidth
         included(i,j,k) = .FALSE.
10    continue
      return
      end
c******************************************************************
      subroutine findpeak(den,nbuff,maxx,maxy,maxz,peak,mpeak,magratio)
      INCLUDE 'sub_find_dimension.inc'
      integer nbuff
      real den(-nbuff+1:maxx+nbuff,-nbuff+1:maxy+nbuff,
     &             -nbuff+1:maxz+nbuff)
      integer peak(3,*)
      integer maxx,maxy,maxz
      real magratio,curpeakthreshold
      curpeakthreshold = peakthreshold * magratio**3

      mpeak = 0
      do k = -nbuff+1, 0
      do j = -nbuff+1, maxy+nbuff
      do i = -nbuff+1, maxx+nbuff
         den(i,j,k) = 0.
      enddo
      enddo
      enddo
      do k = maxz+1, maxz+nbuff
	  do j = -nbuff+1, maxy+nbuff
	  do i = -nbuff+1, maxx+nbuff
	     den(i,j,k) = 0.
	  enddo
	  enddo
	  enddo
	  do k = -nbuff+1, maxz+nbuff
	  do j = -nbuff+1, 0
	  do i = -nbuff+1, maxx+nbuff
	     den(i,j,k) = 0.
	  enddo
	  enddo
	  enddo
	  do k = -nbuff+1, maxz+nbuff
	  do j = maxy+1, maxy+nbuff
	  do i = -nbuff+1, maxx+nbuff
	     den(i,j,k) = 0.
	  enddo
	  enddo
	  enddo
	  do k = -nbuff+1, maxz+nbuff
	  do j = -nbuff+1, maxy+nbuff
	  do i = -nbuff+1, 0
	     den(i,j,k) = 0.
	  enddo
	  enddo
	  enddo
	  do k = -nbuff+1, maxz+nbuff
	  do j = -nbuff+1, maxy+nbuff
	  do i = maxx+1, maxx+nbuff
	     den(i,j,k) = 0.
	  enddo
	  enddo
	  enddo
	  open(12,file='check2.dat')
	  i=8
	  j=4
	  k=5
c  do 39 k = -1,1
c  do 39 j = -1,1
c  do 39 i = -1,1
c     write(12,*) 8-i,4-j,5-k,den(8-i,4-j,5-k)
c39    continue
c  close(12)
      do 10 k = 1, maxz
      do 10 j = 1, maxy
      do 10 i = 1, maxx
         do 20 iz = -1,1
         do 20 iy = -1,1
         do 20 ix = -1,1
            if(den(i,j,k).lt.den(i+ix,j+iy,k+iz)) goto 10
20       continue
         if(den(i,j,k).lt. curpeakthreshold) goto 10
         mpeak = mpeak + 1
         peak(1,mpeak) = i
         peak(2,mpeak) = j
         peak(3,mpeak) = k
10    continue
      return
      end

c******************************************************************
      subroutine insideinclude(peak,inside,mpeak)
      INCLUDE 'sub_find_dimension.inc'
      integer mpeak
      integer inside(mpeak)
      integer peak(3,mpeak)    
      i = 1
10    continue
      if(inside(i).eq.0) then
         do j = i, mpeak-1
            inside(i) = inside(i+1)
            peak(1,i) = peak(1,i+1)
            peak(2,i) = peak(2,i+1)
            peak(3,i) = peak(3,i+1)
         enddo
         mpeak = mpeak - 1
      endif
      i = i + 1
      if(i.gt.mpeak) goto 20
      goto 10
20    continue
      return
      end
c******************************************************************
      subroutine find_min_downhalovalue(valmax,downhalovalue,mpeak)
	  real valmax
	  integer mpeak
	  real downhalovalue(mpeak)
	  valmax = -1.E20
	  do i = 1, mpeak
	     valmax = amax1(valmax,downhalovalue(i))
	  enddo
	  return
	  end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine treehaloparticle(den,pden,nwidth,
     &               maxx,maxy,maxz,np,ppoint,peak,mpeak,haloppoint,
     &               downhalovalue,numhaloseed,endhaloseed,endhalo,
     &               numsubhalo,halo2res,mstep,included,peakincluded,
     &               pvhalo_r,
#ifdef OLD_DEPTH
     &     nposdepth,nxdepth,nydepth,nzdepth
#else
     &     nposdepth
#endif
     &     )
      INCLUDE 'sub_find_dimension.inc'
      real den(-nwidth+1:maxx+nwidth,-nwidth+1:maxy+nwidth,
     &         -nwidth+1:maxz+nwidth)
      integer pden(-nwidth+1:maxx+nwidth,-nwidth+1:maxy+nwidth,
     &             -nwidth+1:maxz+nwidth)
      logical*1 included(-nwidth+1:maxx+nwidth,-nwidth+1:maxy+nwidth,
     &                 -nwidth+1:maxz+nwidth)
#ifdef OLD_DEPTH
      integer nposdepth(0:*)
      integer nxdepth(0:*),nydepth(0:*),nzdepth(0:*)
#else
      integer nposdepth(0:*)
#endif
      logical peakincluded(mpeak)
      integer maxx,maxy,maxz
c     real r(np),vr(np)
      integer haloppoint(mpeak)
      integer ppoint(np)
      integer peak(3,mpeak)
      real downhalovalue(mpeak)
      integer halopp
      integer numhaloseed(mpeak),endhaloseed(mpeak)
c     integer endhalopp
      integer endhalo(mpeak)
      integer numsubhalo
      integer halo2res(mpeak,mstep)
      integer pvhalo_r(10000)

      do i = 1, mpeak
         endhalo(i) = endhaloseed(i)
      enddo

c     valmax = den(peak(1,1),peak(2,1),peak(3,1))
      call find_min_downhalovalue(valmax,downhalovalue,mpeak)
      valmin = backthreshold
	  numsubhalo = 0

      do i = 1, mstep-1
#ifdef CHECK_INFORM
         print *, 'current step ',i,mstep,'in treehaloparticle_ '
#endif
         do j = 1, mpeak
            peakincluded(j) = .FALSE.
         enddo
         threshold = valmax-(valmax-valmin)/real(mstep)*real(i)
#ifdef CHECK_INFORM
         print *, 'just before point_halo_region',threshold
#endif
c------
         do j = 1, mpeak
            npx = peak(1,j)
            npy = peak(2,j)
            npz = peak(3,j)
            if((peakincluded(j).eqv..FALSE.) .and.
#ifdef NEVER_USE
     &         (den(npx,npy,npz).ge. threshold)) then
#else
     &         (downhalovalue(j).gt. threshold)) then
#endif
               peakincluded(j) = .TRUE.
               call point_halo_region(den,nwidth,maxx,maxy,maxz,npx,
     &              npy,npz,threshold,included,ppoint,np,pden,halopp,
#ifdef OLD_DEPTH
     &              nposdepth,nxdepth,nydepth,nzdepth
#else
     &              nposdepth
#endif
     &              )
               if(halopp.eq.0) goto 10
               numsubhalo = numsubhalo + 1
               mtmp = halopp
               ntmp = 0
               do while(mtmp.ne.0) 
                  ntmp = ntmp + 1
                  mtmp = ppoint(mtmp)
               enddo
			   pvhalo_r(numsubhalo) = halopp
               halo2res(j,i) = numsubhalo
            else
               goto 10  ! goto next peak
            endif
            do k = 1, mpeak
               if(k.eq.j) goto 20
               npx = peak(1,k)
               npy = peak(2,k)
               npz = peak(3,k)
               if(included(npx,npy,npz).eqv..TRUE.) then
                  peakincluded(k) = .TRUE.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      ̰  ϴ   ...
c                 write(20) k
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
                  halo2res(k,i) = numsubhalo
               endif         
 20            continue
            enddo
 10         continue
         enddo
#ifdef CHECK_INFORM
         print *, 'end of step ',i,mstep,'in treehaloparticle_ '
#endif
      enddo
c This part is intended to avoid of exceeding memory in
c point_halo_region where ndepth is limited but box size is so large.
#ifdef CHECK_INFORM
      print *, 'Before scoop_residual'
#endif
      call scoop_residual(den,nwidth,maxx,maxy,maxz,included,
     &                      ppoint,np,pden,halopp)
      if(halopp.eq.0) return
      numsubhalo = numsubhalo + 1
      pvhalo_r(numsubhalo) = halopp
      do k = 1, mpeak
          halo2res(k,mstep) = numsubhalo
      enddo
#ifdef CHECK_INFORM
      print *, 'End of scoop_residual'
#endif

      return
      end
