#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<mpi.h>
#include"Memory.h"
#include "./Tree/tree.h"
#include "defs.h"
#include "header.h"
static int tidal_start=1;
float m_tidal[NUM_MASS],r_tidal[NUM_MASS];
int Parallel;
struct HaloPos *hr;
struct HaloVel *hvr;
lint *hhasptl;
float *den;
lint *den2ptl;

int magnitude;
int myrank,nrank;
int shalonum,rhalonum;
lint *pt2h;
int tnp;
struct PtlPos *sx,*rx,*tr;
struct PtlVel *svx,*rvx;
lint *sindx;
lint *rindx;
lint *ptl2halonum;
int mpeak;
int ready=READY,writing=WRITING;
int snp,rnp;
FILE *wp;
/*                              */
float amax,a,rng,size,hubble;
int ng,nspace;
float omep,omeplam,epsilon;
int nx,ny,nz;
/*                              */
double com2real,real2com;
double pntmass,r1kineticfact,r2kineticfact;
double potentfact;
float acoeff[8];
double onesolarmass=1.989E33;

void write_data(struct PtlPos *,struct PtlVel *,lint *,lint*,int);
void HDF_write_data(struct PtlPos *,struct PtlVel *,lint *,int);
extern int physical_parameters(void);
int subhalo_den(struct PtlPos *,struct PtlVel *, lint *, lint,float ,lint *,
		int);
float find_tidal_Rc(struct PtlPos *,lint ,struct PtlPos *,lint ,
	        struct HaloPos *,struct HaloVel *,struct HaloPos *,
	        struct HaloVel *,int,int);
int num_pick_up_r_ptl(struct PtlPos *,int ,int *,struct PtlPos *,int );
void pspline_(void);


/*
int hfind(Ng,Nspace,Omep,Omeplam,Hubble,Size,Amax,Aa,Epsilon,Hh,Magnitude,nstep,
		Myrank,Nrank)
	int Ng,Nspace,Magnitude;
	float Omep,Omeplam,Hubble,Size,Amax,Aa,Epsilon,Hh;
	int nstep;
	int Myrank,Nrank;
	*/
MAIN_(int argc, char *argv[])
{
	/*
	MPI_Status mstatus,cstatus;
	MPI_Request request;
	char filetag[80],filename[80];
	int i,j,snp,rnp,flag;
	int ib;
	int finish=-99999;
	int snend,rnend;
	int nstep;
	int src,dest;
	int job,check;
	struct HaloPos *csx,*crx;
	struct HaloVel *csvx,*crvx;
	float tmp_tidal,tmp;
	float *floatsx, *floatrx;
	int *swap;
	lint *pptr;
	float *potent,*tmppotent;
	float h;
	FILE *fp,*rtidalf;
	int OldStackNum;
	char rfilename[80],wfilename[80];
	*/



	(void )MPI_Init(&argc,&argv);
	(void )MPI_Comm_rank(MPI_COMM_WORLD,&myrank);
	(void )MPI_Comm_size(MPI_COMM_WORLD,&nrank);
		fprintf(stderr,".... hfind.exe [ng] [nspace] [omep] [omeplam] [hubble] [size] [amax] [a] [epsilon] [h] [mag] [nstep]\n");
	/*
	MPI_Errhandler_set(MPI_COMM_WORLD,errhandler);
	*/
	/*
	if(argc != 13){
		if(myrank == motherrank)
		fprintf(stderr,".... hfind.exe [ng] [nspace] [omep] [omeplam] [hubble] [size] [amax] [a] [epsilon] [h] [mag] [nstep]\n");
		exit(1);
	}

	(void)Make_Total_Memory();
	if(myrank == motherrank && tidal_start == 1){
		rtidalf = fopen("tidal.dat","r");
		for(i=0;i<NUM_MASS;i++){
			fscanf(rtidalf,"%g %g %g\n",&m_tidal[i],&r_tidal[i],&tmp);
		}
		fclose(rtidalf);
		tidal_start = 0;
	}
	MPI_Finalize();
	return;
	*/
}
void initden_(lden,nwidth,maxx,maxy,maxz,mpeak,peak)
	float *lden;
	int *nwidth,*maxx,*maxy,*maxz,*mpeak;
	int *peak;
{
	int ready;
	int i,j,k;
	int nsize;
	MPI_Status mstatus,cstatus;
	MPI_Request request;
	for(i=1;i<nrank;i++){
		MPI_Recv(&ready,1,MPI_INT,i,READY,MPI_COMM_WORLD,&cstatus);
		ready = DEN_TAG;
		MPI_Send(&ready,1,MPI_INT,i,0,MPI_COMM_WORLD);
		nsize = (*maxx+2**nwidth)*(*maxy+2**nwidth)*(*maxz+2**nwidth);
		MPI_Send(nwidth,1,MPI_INT,i,DEN_TAG1,MPI_COMM_WORLD);
		MPI_Send(maxx,1,MPI_INT,i,DEN_TAG2,MPI_COMM_WORLD);
		MPI_Send(maxy,1,MPI_INT,i,DEN_TAG3,MPI_COMM_WORLD);
		MPI_Send(maxz,1,MPI_INT,i,DEN_TAG4,MPI_COMM_WORLD);
		MPI_Send(mpeak,1,MPI_INT,i,DEN_TAG5,MPI_COMM_WORLD);
		MPI_Send(lden,nsize,MPI_FLOAT,i,DEN_TAG6,MPI_COMM_WORLD);
		MPI_Send(peak,(*mpeak)*3,MPI_INT,i,DEN_TAG7,MPI_COMM_WORLD);
	}
}
void bin2ascii(struct PtlPos *,struct PtlVel *,lint );
void write_data(struct PtlPos *rrx,struct PtlVel *rrvx,lint *rrindx,
		lint *rptl2halonum,int rrnp){
	struct PtlPos *wr;
	struct PtlVel *wvr;
	lint *windx;
	int wnp;
	int i,j,k;

#ifdef CHECK_HALO_SAVING
	if(myrank == 0 && mpeak >0 ) {
		fprintf(stderr,"Halo group has %d particles... saving..",rrnp);
		fflush(stderr);
	}
#endif
#ifdef NEVER
	for(i=0;i<rrnp;i++){
		if(rrindx[i] <= 0)
		fprintf(stderr,"Error %d %g %g %g\n",rrindx[i],rrx[i].x,rrx[i].y,rrx[i].z);
	}
#endif

	if (mpeak > 0){
        fwrite(&mpeak,sizeof(int),1,wp);
		wr = (struct PtlPos *)Malloc(sizeof(struct PtlPos)*rrnp,PPTR(wr));
		wvr = (struct PtlVel *)Malloc(sizeof(struct PtlVel)*rrnp,PPTR(wvr));
		windx = (lint *)Malloc(sizeof(lint)*rrnp,PPTR(windx));
		for(i=0;i<mpeak;i++){
			wnp = 0;
			for(j=0;j<rrnp;j++){
				if(rptl2halonum[j] == i){
					wr[wnp].x = rrx[j].x*size/(float) ng;
					wr[wnp].y = rrx[j].y*size/(float) ng;
					wr[wnp].z = rrx[j].z*size/(float) ng;
					wvr[wnp].vx = rrvx[j].vx*r2kineticfact/100000.;
					wvr[wnp].vy = rrvx[j].vy*r2kineticfact/100000.;
					wvr[wnp].vz = rrvx[j].vz*r2kineticfact/100000.;
					windx[wnp] = rrindx[j];
					wnp++;
				}
			}
			fwrite(&wnp,sizeof(lint),1,wp);
			fwrite(wr,sizeof(struct PtlPos),wnp,wp);
			fwrite(wvr,sizeof(struct PtlVel),wnp,wp);
			fwrite(windx,sizeof(lint),wnp,wp);
#ifdef CHECK_HALO_SAVING
			fprintf(stdout,"in %d halos ,halomass %12G %d \n",mpeak,pntmass*wnp/onesolarmass,wnp);
			fflush(stdout);
#endif
		}
		Free(windx);
		Free(wvr);
		Free(wr);
	}
#ifdef CHECK_HALO_SAVING
	if(myrank == 0 && mpeak >0 ) {
		fprintf(stderr,"saved.\n");
	}
#endif
#ifdef CHECK_HALO
    bin2ascii(rrx,rrvx,rrnp);
#endif
	fflush(wp);
}
void minmax(struct PtlPos *,int ,float *,float *, float *,float *,float *, float *,float *);
void bin2ascii(struct PtlPos *r,struct PtlVel *vr,lint np)
{
	int i,j;
	FILE *fp,*fpt,*fptz;
	char char1;
	float minx,minz,maxx,maxz,miny,maxy,width;
	int uline,dline;
	char *ctype[] = {"yellow", "blue", "red","green","6",
	"magenta","6","7","8","5","4","3","0","yellow","blue","red",
	"magenta","6","7","8","5","4","3","0","yellow","blue","red",
	"magenta","6","7","8","5","4","3","0","yellow","blue","red",
	"magenta","6","7","8","5","4","3","0","yellow","blue","red",
	"magenta","6","7","8","5","4","3","0","yellow","blue","red",
	"magenta","6","7","8","5","4","3","0","yellow","blue","red",
	"magenta","6","7","8","5","4","3","0","yellow","blue","red" };
	fp = fopen("halo0.dat","w");
	fpt = fopen("r.sm","w");
	fptz = fopen("z.sm","w");
	fprintf(fpt,"erase \n");
	fprintf(fptz,"erase \n");
	fprintf(fpt,"ticksize 0.1 1 0.1 1 \n");
	fprintf(fptz,"ticksize 0.1 1 0.1 1 \n");
	fprintf(fpt,"data halo0.dat \n");
	fprintf(fptz,"data halo0.dat \n");
	fprintf(fpt," ptype 0 0 \n");
	fprintf(fptz," ptype 0 0 \n");
	minmax(r,np,&minx,&maxx,&miny,&maxy,&minz,&maxz,&width);
	minx = floor(minx);minz = floor(minz);width = ceil(width)+1;
	fprintf(fpt," limits %f %f %f %f \n",minx,minx+width,minz,minz+width);
	fprintf(fptz," limits %f %f %f %f \n",minx,minx+width,miny,miny+width);
	fprintf(fpt," ctype default \n");
	fprintf(fptz," ctype default \n");
	fprintf(fpt," expand 1.2 \n");
	fprintf(fptz," expand 1.2 \n");
	fprintf(fpt," box \n");
	fprintf(fptz," box \n");
	fprintf(fpt," expand 0.3 \n");
	fprintf(fptz," expand 0.3 \n");
	uline = 1;dline = 0;
	for(j=0;j<mpeak;j++){
		for(i=0;i<np;i++){
			if(ptl2halonum[i] == j){
			fprintf(fp,"%f %f %f %f %f %f \n",r[i].x,r[i].y,r[i].z,
					vr[i].vx,vr[i].vy,vr[i].vz);
			dline++;
			}
		}
		fflush(fp);
		if(dline > uline ){
		fprintf(fpt," lines %d %d \n",uline,dline);
		fprintf(fptz," lines %d %d \n",uline,dline);
		fprintf(fpt," read { x 1 y 2 z 3} \n");
		fprintf(fptz," read { x 1 y 2 z 3} \n");
  		fprintf(fpt," ctype %s \n",*(ctype+j));
  		fprintf(fptz," ctype %s \n",*(ctype+j));
		fprintf(fpt," points x z \n");
		fprintf(fptz," points x y \n");
		fflush(fpt);
		}
		uline = dline + 1;
	}
	/* ̹  ׶ ƼŬ̴. */
	uline = dline;
	for(i=0;i<np;i++){
		if(ptl2halonum[i]<0){
			fprintf(fp,"%f %f %f %f %f %f \n",r[i].x,r[i].y,r[i].z,
					vr[i].vx,vr[i].vy,vr[i].vz);
			dline++;
		}
	}
	fprintf(fpt," lines %d %d \n",uline,dline);
	fprintf(fptz," lines %d %d \n",uline,dline);
	fprintf(fpt," read { x 1 y 2 z 3} \n");
	fprintf(fptz," read { x 1 y 2 z 3} \n");
  	fprintf(fpt," ctype default \n");
  	fprintf(fptz," ctype default \n");
	fprintf(fpt," points x z \n");
	fprintf(fptz," points x y \n");
	fflush(fpt);
	fflush(fptz);
	fclose(fpt);
	fclose(fptz);
	fflush(fp);
	fclose(fp);
	printf("input arbitrary value : ");
	char1 = getc(stdin);
	fflush(stdin);
}

void minmax(struct PtlPos *r,int np,float *minx,float *maxx,
		float *miny,float *maxy,float *minz,
		float *maxz,float *width){
	int i;
	*minx = *miny = *minz = 1000;
	*maxx = *maxy = *maxz = 0;
	for(i=0;i<np;i++){
		*minx = MIN(*minx,r[i].x);
		*miny = MIN(*miny,r[i].y);
		*minz = MIN(*minz,r[i].z);
		*maxx = MAX(*maxx,r[i].x);
		*maxy = MAX(*maxy,r[i].y);
		*maxz = MAX(*maxz,r[i].z);
	}
	*width = MAX(*maxx-*minx,*maxz-*minz);
	*width = MAX(*width,*maxy-*miny);
	*width = MAX(*width,4.);
}
